svn commit: r329147 - in head/etc: defaults rc.d

Warner Losh imp at FreeBSD.org
Mon Feb 12 04:45:18 UTC 2018


Author: imp
Date: Mon Feb 12 04:45:17 2018
New Revision: 329147
URL: https://svnweb.freebsd.org/changeset/base/329147

Log:
  Add devmatch rc.d integration
  
  Create simple script to load modules on demand based on the device
  identifying information.
  
  Sponsored by: Netflix

Added:
  head/etc/rc.d/devmatch   (contents, props changed)
Modified:
  head/etc/defaults/rc.conf

Modified: head/etc/defaults/rc.conf
==============================================================================
--- head/etc/defaults/rc.conf	Mon Feb 12 01:17:06 2018	(r329146)
+++ head/etc/defaults/rc.conf	Mon Feb 12 04:45:17 2018	(r329147)
@@ -41,6 +41,7 @@ ddb_enable="NO"		# Set to YES to load ddb scripts at b
 ddb_config="/etc/ddb.conf"	# ddb(8) config file.
 devd_enable="YES" 	# Run devd, to trigger programs on device tree changes.
 devd_flags=""		# Additional flags for devd(8).
+devmatch_enable="NO"	# Demand load kernel modules based on device ids.
 #kld_list="" 		# Kernel modules to load after local disks are mounted
 kldxref_enable="NO"	# Build linker.hints files with kldxref(8).
 kldxref_clobber="NO"	# Overwrite old linker.hints at boot.

Added: head/etc/rc.d/devmatch
==============================================================================
--- /dev/null	00:00:00 1970	(empty, because file is newly added)
+++ head/etc/rc.d/devmatch	Mon Feb 12 04:45:17 2018	(r329147)
@@ -0,0 +1,54 @@
+#!/bin/sh
+
+# Copyright (c) 2018 Warner Losh
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+#    notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in the
+#    documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+#
+# $FreeBSD$
+#
+# PROVIDE: devmatch
+# REQUIRE: kldxref
+# KEYWORD: nojail
+
+. /etc/rc.subr
+
+name="devmatch"
+desc="Use devmatch(8) to load kernel modules
+
+start_cmd="${name}_start"
+stop_cmd=':'
+
+devmatch_start()
+{
+	local x
+
+	x=$(devmatch | sort -u)
+
+	[ -n "$x" ] || return
+
+	echo "Autoloading modules"
+	kldload ${x}
+}
+
+load_rc_config $name
+run_rc_command "$1"


More information about the svn-src-head mailing list